#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <float.h>
#include <limits.h>

#include "m.h"
#include "g.h"
#include "fit.h"

static char rcsid[] = {"$Id: fitcmdinit.c,v 1.1.1.1 1997/07/10 17:59:59 kraemer Exp $"};

extern struct SFIT sFit;
/*
   --- Command processor for the FINIT command

   Copyright  (C) 1987-1997 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved
   $Log: fitcmdinit.c,v $
   Revision 1.1.1.1  1997/07/10 17:59:59  kraemer
   revision for cvs

*/

void fitCmdInit(
                long *plRelease,
                long *plNoConfirm,
                long *plDebug
               ) {
   int iRC = ERRFIT_BADADDR;
   char *pDbgMsg = __FILE__, *pMsg = pDbgMsg;
   unsigned long lFlag = 0;


   if ( *plDebug ) lFlag |= FIT_DEBUG;
if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s.....\n", pDbgMsg );
                                      /* confirm action */
   if ( !*plNoConfirm && _systso() )
      if ( ! _pyes( "Confirm" ) ) { iRC = 0; goto gError; }
                                      /* flast/clear */
   fitFctBlkFree( &sFit.sFFB, lFlag );
                                      /* fwin/all */
   fitWdwListFree( &sFit.sListFW, lFlag );
                                      /* ferr/none */
   sFit.sFDE.lMode = 0;
                                      /* fxcal 0 1 */
   fitCalInit( &sFit.sFCalX, lFlag );
                                      /* default = least squares */
   sFit.lStatus &= ~FIT_POISSON;
                                      /* default = gaussian peaks */
   sFit.lStatus &= ~FIT_LORENTZPEAK;
                                      /* delete all other entries */
   if ( *plRelease ) {
      fitDataFree( &sFit.sFD, lFlag );
      fitDataFree( &sFit.sFDFit, lFlag );
   }

   iRC = 0;
gError:;
   if ( (iRC < 0) && !(lFlag&FIT_NOMSG) ) {
      fitemsg( pMsg, iRC );
   }
if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s done\n", pDbgMsg );
   return;
}
