#include <pthread.h>
#if defined(AMIGA)
#else
#include <in.h>
#include <netdb.h>
#include <socket.h>
#endif

#include "u.h"
/*
   $Log: io.h,v $
   Revision 1.3  1999/07/05 17:57:48  kraemer
   special processing for converted lmdi-files

   Revision 1.2  1999/06/18 11:56:36  kraemer
   stuff for HG's rev

   Revision 1.1.1.1  1997/07/10 19:24:13  kraemer

*/
/*
   --- flags
*/
                      /* flags for started subsystems */
#define IO_CMDINIT 0x00000001     /* cmd subsystem */
#define IO_DINIT   0x00000002     /* basic display subsystem */
#define IO_FITINIT 0x00000004     /* fit subsystem */
#define IO_ANLINIT 0x00000008     /* analyzer subsystem */
                      /* system status flags */
#define IO_SYSINIT   0x00000001     /* system is initialized */
#define IO_SYSTSO    0x00000002     /* Foreground run */
#define IO_SYSTBV    0x00000004     /*  */
#define IO_SYSDUMP   0x00000008     /*  */
#define IO_SYSREPORT 0x00000010     /*  */
#define IO_SYSGO     0x00000020     /*  */
#define IO_SYSEXIT   0x00000040     /*  */
#define IO_SYSSWAP   0x00000080     /* data swap needed */

#define IO_SYSDEBUG  0x80000000     /* global debug */
#define IO_SYSEDAS   0x00000100     /* EDAS data file active */
#define IO_SYSGOOSY  0x00000200     /* GOOSY data file active */
#define IO_SYSPENDING 0x00000400    /* I/O in progress */
#define IO_SYSONLINE 0x00000800     /* online event service */
#define IO_SYSNOCONF 0x40000000     /* suppress confirmation */
/*
   --- EDAS file structures ----------------------------------------------
*/
                         /* fileheader */
struct SFILEHEAD {
   unsigned char cPreXFer[32];    /* pre-transfer header */
   short iDataMax;                /* data block header ... */
   char cSpare0, cDataType, c0, cSubType, cBmax, cBcur; /* 0,0,0,0,1,1 */
   long lBlockNo;
   short iType, iFileNo;
   unsigned char cTapeLabel[6], cSpare[2], cDate[7], cCode;
   long lTimeOfDay;
   unsigned char cRun[8], cExp[8];
   short iComLen;
   unsigned char cComment[4010];
};
                         /* filedata */
struct SFILEDATA {
   char cPreXFer[32];             /* pre-transfer header */
   short iDataMax;                /* data block header */
   unsigned char bBits, cDataType, cSpare, cSubType, cBmax, cBcur;
   long lBlockNo;
   unsigned char cData[4052];
};

/*
   --- GOOSY file structures --------------------------------------------
*/
                              /* buffer header (48 bytes) for lmdi-converted files */
struct SSABUFHELMDI {
   short iDLen, iDummy; 
   short iType, iSubType;
   short iUsed;
   unsigned char cEnd, cBeg;  /* fragment end/begin */
   unsigned long lBuf, lEvt;  /* current buffer number, # of fragments */
   long lCurrent;             /* 0/1=VAX, -1=IBM */
   unsigned long lTime[2];    /* VMS time stamp */
   unsigned long lByteSex;    /* 1: OK, else: longword swap */
   unsigned long lLastEventLen; /*  */
   unsigned long lFree[2];    /* reserved */
};
                              /* buffer header (48 bytes) */
struct SSABUFHE {
                /* data length, total length, type/subtype, used length */
   long lDLen; 
#if defined(U_BIG_ENDIAN)
   short iSubType, iType;
   unsigned char cBeg, cEnd;  /* fragment end/begin */
   short iUsed;
#elif defined(U_LITTLE_ENDIAN)
   short iType, iSubType;
   short iUsed;
   unsigned char cEnd, cBeg;  /* fragment end/begin */
#else
#error you loose, unknown endian
#endif
   unsigned long lBuf, lEvt;  /* current buffer number, # of fragments */
   long lCurrent;             /* 0/1=VAX, -1=IBM */
   unsigned long lTime[2];    /* VMS time stamp */
   unsigned long lByteSex;    /* 1: OK, else: longword swap */
   unsigned long lLastEventLen; /*  */
   unsigned long lFree[2];    /* reserved */
};
                              /* event/buffer element header */
struct SSAEVHE {
                              /* data length, type/subtype */
   long lDLen; 
#if defined(U_BIG_ENDIAN)
   short iSubType, iType;
#elif defined(U_LITTLE_ENDIAN)
   short iType, iSubType;
#else
#error you loose, unknown endian
#endif   
};
                              /* event header type 4 (8 bytes) */
struct SSAEVHE4 {
                              /* data length, total length, type/subtype */
   short iDLen, iDummy; 
   short iType, iSubType;
};
                              /* event header type 10 (VME,SBS), after swapl()
                                (16 bytes) */
struct SSAVE10 {
   long lDLen;
#if defined(U_BIG_ENDIAN)
   short iSubType, iType;     /* 10,1/2/3 */
   short iTrigger;
   short iDummy;
#elif defined(U_LITTLE_ENDIAN)
   short iType, iSubType;     /* 10,1/2/3 */
   short iDummy;
   short iTrigger;
#else
#error you loose, unknown endian
#endif
   long  lCounter;            /* event counter */
};
                              /* CAMAC data after swapl() 
                              */
struct SSAVES101 {
#if defined(U_BIG_ENDIAN)
   short iCAMVal, iCAMID;
#elif defined(U_LITTLE_ENDIAN)
   short iCAMID, iCAMVal;
#else
#error you loose, unknown endian
#endif
};
                              /* subevent type 10 (VME,SBS), after swapl() 
                              */
struct SSAVES10 {
   long lDLen;
#if defined(U_BIG_ENDIAN)
   short iSubType, iType;     /* 10,1/2/3 */
   unsigned char cControl, cSubCrate;
   short iProcID;
#elif defined(U_LITTLE_ENDIAN)
   short iType, iSubType;     /* 10,1/2/3 */
   short iProcID;
   unsigned char cSubCrate, cControl;
#else
#error you loose, unknown endian
#endif
};
                              /* file header */
struct SC78VAR { short i78; char c78[78]; };
struct SSAFILHE {
   struct SSABUFHE sBFH;
   short iLabel; char cLabel[30];
   short iFile;  char cFile[86];
   short iUser;  char cUser[30];
                 char cTime[24];
   short iRun;   char cRun[66];
   short iExp;   char cExp[66];
   long  lLines;
   char  cData[8192-sizeof(struct SSABUFHE)-32-88-32-24-68-68-4];
};
/*
   --- GOOSY buffer types
*/
#define GOOFHD     2000      /* file header */
#define GOOACK     3000      /* acknowledge */
#define GOOMBD_NOSTD  1      /* non-standard MBD */
#define GOOSILENA_J11 2      /* J11-generated SILENA data */
#define GOOEVT3       3      /* compressed buffer elements type 3 */
#define GOOEVT4       4      /* events type 4 */
#define GOOFERA_STD   5      /* LRS FERA events */
#define GOOMBD_STD    6      /* J11-generated MBD events, standard */
#define GOOMBD_USR    7      /* J11-generated MBD events, user structure */
#define GOOVME       10      /* VME events */
#define GOOSILENA_FERA 12    /* FERA-generated SILENA data */
#define GOOFERA_NOSTD  15    /* LRS FERA events */
#define GOOELM     1000      /* GOOSY data element */
#define    GOOSPC     1      /* spectrum */
#define    GOOCND     2      /* condition */
#define    GOOPIC     3      /* picture */
#define    GOOPOL     4      /* polygon */
#define    GOOCAL     5      /* calibration */
#define    GOOANY     6      /* data element */
#define GOOMAINZ  10101      /* external user buffer Mainz */
#define GOOTHD    10102      /* external user buffer THD */
#define GOOCAVEB  10103      /* external user buffer CAVE B */
                             /* any buffer may contain element types */
#define GOOTIME     9000     /* GOOSY time stamps */
#define GOOCAMACTAB 2001     /* CAMAC readout table */
#define    GOOTABINIT  1     /* table init */
#define    GOOTABRO    2     /* table read out */
#define    GOOTABRESET 3     /* table reset */
#define GOOFBTAB    2002     /* fastbus readout table */
#define GOOVMETAB   2003     /* VME readout table */
/*
   --- event sorting tables
*/
#define MSRTTBL 5    /* primary allocation extent */
struct SSRTTBL {
   int (*eSrt)();   /* entry to be called, if NULL, end of list */
   short iType, iSubType;
};
/*
   --- "neutral" I/O file header
*/
struct SIOFHD {
   char *pLabel, *pFile, *pUser, *pDate, *pTime, *pRun, *pExp;
   char *pCom;
};
/*
   --- I/O master structure
*/
#define MIODATA 16384       /* initial length */
#define MIODSN  255

#undef ONLINERSM

#if defined(ONLINERSM)

#include "gps_sc_def.h"                 /* must be first: contains
                                         * #define statements         */
#include "f_stccomm.h"                  /* port server stuff  */
#include "clnt_buf_def.h"
#include "s_filter.h"
#include "s_clntbuf.h"

#if defined(U_BIG_ENDIAN)                /* big ENDIAN ?                 */

#include "s_flt_descr_swap.h"
#include "s_opc1_swap.h"
#include "s_pat_swap.h"
#include "s_clnt_filter_swap.h"
#include "sa_event_swap.h"

#endif

#if defined(U_LITTLE_ENDIAN)             /* little ENDIAN ?                 */

#include "s_flt_descr.h"
#include "s_opc1.h"
#include "s_pat.h"
#include "s_clnt_filter.h"
#include "sa_event.h"

#endif


#define F__SWAP(ps,l,pd) swapl(ps,ps,l)

struct SIORSM {
   char *pcNodeName;
   struct s_clntbuf *psCB;
   unsigned long lf_swap, l_endian_serv;
   int iChannel;
   struct s_tcpcomm sTCPComm;
   struct s_clnt_filter sCF;
};
#endif

#define ONLINEHG

#if defined(ONLINEHG)
struct SIOREV {
   unsigned long ulFlag;
   char *pcNode;
   int iPort;
   int iSocket;
//   struct hostent sHE;
   int nv, mv;
   void *pv;
};

#define IOREV_CONNECTED 0x00000001

#endif


struct SIO {
   unsigned long lDebug;             /* enables debug mode: lots of output */
   unsigned long lExit;              /* 1/0: EXIT command given/not given */
   unsigned long lSubSystem;
   unsigned long lStatus;
   long lLastBufNo;
   int nSrtTbl;             /* allocated size of sort table */
   struct SSRTTBL *pSrtTbl; /* ptr. to sorting table
                               to map type/subtypes to routines */
   FILE *fp;
   void *pData;             /* data I/O buffer */
   int  nData;              /* current length in bytes */

   struct SIOFHD sIOFHD;    /* file header info */

   pthread_mutex_t MutexCompletion;
   pthread_cond_t CondCompletion;
   pthread_mutex_t Mutex;
   pthread_cond_t Cond;
   pthread_t Thread;
#if defined(ONLINERSM)
   struct SIORSM sRSM;      /* RSM's strange stuff */
#endif

#if defined(ONLINEHG)
   struct SIOREV sIR;
#endif

   char cDSN[MIODSN+1];
};

/*
   --- function definitions ----------------------------------------------
*/

int _iorevClose( struct SIOREV *, unsigned long );
int _iorevFlush( struct SIOREV *, unsigned long );
int _iorevInit ( struct SIOREV *, unsigned long );
int _iorevOpen ( struct SIOREV *, const char *, int, unsigned long );
int _iorevRead ( struct SIOREV *, unsigned long );


void _ioinp( char *, char *, char *, char *, char *, char *,
             long *, long *, long *, long * );
void _iocmdhalt( void );
void _iocmdgo( long *, long *, long * );

void _iohalt( void );
void _iogo( void );
int _ioopen( void );
int _ioread( void );
int _ioclose( void );
int _ioinit( unsigned long );
int _ioterm( unsigned long );
void _ioend( void );
void _ioexit( void );

int _init(void);
int _listinit(void);
int _list (void *, long, long);
int _list7(void *, long, long);

int _srtdef( short, short, int (*) (void) );
int _evttp3( void );
int _evttp7( void );
int _srt00( void );
int _goo61( void );
int _goov( void );
int _goo2000( void );
int _gooswpbh( struct SSABUFHE *, unsigned long );
int _goo4x   ( void *, unsigned long );
int _goo10x  ( void *, unsigned long );

void *_goofrgw( struct SSAEVHE4 *, void  * );
void *_goofrgl( struct SSAEVHE *, void  * );

void _ioemsg( char *, int );
/*
   --- error codes ------------------------------------------------------
*/
#define ERRIO_SYS -1
#define ERRIO_INIT        -2
#define ERRIO_NOFILE      -3
#define ERRIO_NOGOOFHD    -4
#define ERRIO_INVDATALEN  -5
#define ERRIO_INVDATATYPE -6
#define ERRIO_NOINIT      -7
#define ERRIO_OPENFAILED  -8
#define ERRIO_READFAILED  -9
#define ERRIO_NOOPEN      -10
#define ERRIO_FORMAT      -11
#define ERRIO_ADCZERO     -12    
#define ERRIO_UNKNOWNBUFFER -13
#define ERRIO_BUFFERNOTYET  -14
#define ERRIO_MUTEXLOCK   -15
#define ERRIO_MUTEXUNLOCK -16
#define ERRIO_CONDSIGNAL  -17
#define ERRIO_EVTDEF      -18
#define ERRIO_SRTDEF      -19
#define ERRIO_INVEP       -20
#define ERRIO_EVTFIL      -21
#define ERRIO_INVPTR      -22
#define ERRIO_EVTPTR      -23
#define ERRIO_INVBUFTYPE  -24
#define ERRIO_INVEVTTYPE  -25
#define ERRIO_NOLEADFRAG  -26

#define ERRIO_BADADDR     -27
#define ERRIO_BADPORT     -28
#define ERRIO_BADHOST     -29
#define ERRIO_REVINITFAILED -30
#define ERRIO_BADNODE     -31
#define ERRIO_BADLENGTH   -32
#define ERRIO_ALREADYRUNS -33
