#ifndef IOERR_H
#define IOERR_H
/*
   Definitions for I/O error handling
   ===================

   Copyright  (C) 1995-2000 M.Kraemer, GSI Darmstadt,
                             all rights reserved   

   $Log: ioerr.h,v $
   Revision 1.3  2003/06/12 11:33:52  kraemer
   support MR2000, ATMD Daq (V.Dangendorf/F.Kaufmann)

   Revision 1.2  1999/07/26 19:01:57  kraemer
   various bugs fixed: event defragmentation, error codes, file name keeping

   Revision 1.1  1999/07/17 16:18:51  kraemer
   major overhaul of edas/goosy buffer and swap logic


*/

                                      /* */

void _ioemsg( char *, int );
                                      /* */
#define ERRIO_SYS         -1
#define ERRIO_INIT        -2
#define ERRIO_NOFILE      -3
#define ERRIO_BADDATALEN  -4
#define ERRIO_BADDATATYPE -5
#define ERRIO_NOINIT      -6
#define ERRIO_OPENFAILED  -7
#define ERRIO_READFAILED  -8
#define ERRIO_NOOPEN      -9
#define ERRIO_FORMAT      -10
#define ERRIO_MUTEXLOCK   -11
#define ERRIO_MUTEXUNLOCK -12
#define ERRIO_CONDSIGNAL  -13
#define ERRIO_EVTDEF      -14
#define ERRIO_BADEVTPTR   -15
#define ERRIO_BADEVTTYPE  -16
#define ERRIO_NOLEADFRAG  -17
#define ERRIO_BADADDR     -18
#define ERRIO_BADPORT     -19
#define ERRIO_BADHOST     -20
#define ERRIO_REVINITFAILED -21
#define ERRIO_BADNODE       -22
#define ERRIO_BADLENGTH     -23
#define ERRIO_ALREADYRUNS   -24
#define ERRIO_BUFFERNOTYET  -25
#define ERRIO_NOTGOOSY      -26

#define ERRIO_BADCAMACNODE    -27
#define ERRIO_BADCAMACSTATION -28
#define ERRIO_CAMACOPENFAILED -29
#define ERRIO_CDREGFAILED     -30 
#define ERRIO_CFUBRFAILED     -31
#define ERRIO_CAMACNOX        -32  
#define ERRIO_CAMACDATAXFERFAILED -33
#define ERRIO_CAMACCNAFFAILED     -34

#define ERRIO_BADANLTYPE   -35
#define ERRIO_BADANLDIM    -36 
#define ERRIO_EVTDEFFAILED -37
#define ERRIO_ANLDEFFAILED -38
#define ERRIO_ACHECKFAILED -39
#define ERRIO_ASTSPCFAILED -40

//#define

#endif
