#ifndef M_M_H 
#define M_M_H

/*
   $Log: m.h,v $
   Revision 1.7  2000/04/03 12:31:38  kraemer
   c2* and other prototypes

   Revision 1.6  1999/12/16 12:42:55  kraemer
   prototypes added

   Revision 1.5  1999/02/02 19:56:24  kraemer
   function prototypes added (random generators)

   Revision 1.4  1997/12/15 17:28:41  kraemer
   branches for native gammafunction, nan declarations

   Revision 1.3  1997/07/10 17:26:10  kraemer
   *** empty log message ***

   Revision 1.2  1997/06/16 18:15:51  kraemer
   more prototypes

*/

#define GT 1
#define LT 2
#define NE 3
#define EQ 4
#define GE 5
#define LE 6

#ifndef min
#define min(a,b) ( (a) < (b) ) ? (a) : (b)
#endif

#ifndef max
#define max(a,b) ( (a) > (b) ) ? (a) : (b)
#endif
 
#if defined(AMIGA)
 
#if defined(M881) || defined(M040) || defined(M060)
 
#include <m68881.h>
#undef  floor
#define floor floor
 
/*
#define DBL_MIN     2.2250738585072014e-308
*/
/*
union UDDLL { unsigned long ll[2]; double dd; };
static union UDDLL uDBL_MIN = { 0x00100000, 0x00000000 };
#undef DBL_MIN
#define DBL_MIN (uDBL_MIN.dd)
*/
 
//#define FLT_MIN     1.1754943508222875e-38F
/* DBL_MAX(AIX) = 7FEFFFFF FFFFFFFF */

//#define FLT_EPSILON        1.1920928955078125e-7
//#define DBL_EPSILON        2.2204460492503131e-16
 
#elif defined(MFFP)
 
#undef DBL_MAX
#undef FLT_MAX
#undef DBL_MIN
#undef FLT_MIN
#define DBL_MAX 9.2233717E18
#define FLT_MAX 9.2233717E18
//#define DBL_MIN 2.7105E-20
//#define FLT_MIN 2.7105E-20
 
union UDDLL { unsigned long ll; double dd; };

static union UDDLL uDBL_MIN = { 0x80000000 };
#undef DBL_MIN
#define DBL_MIN (uDBL_MIN.dd)
#define FLT_MIN DBL_MIN

static union UDDLL uDBL_EPSILON = { 0x8000002A };
#undef DBL_EPSILON
#define DBL_EPSILON (uDBL_EPSILON.dd)
#undef FLT_EPSILON
#define FLT_EPSILON DBL_EPSILON
 
#elif defined(MIEEE)              /* MIEEE */
 
union UDDLL { unsigned long ll[2]; double dd; };
static union UDDLL uDBL_MIN = { 0x00100000, 0x00000000 };
#undef DBL_MIN
#define DBL_MIN (uDBL_MIN.dd)
 
//#define FLT_MIN     1.1754943508222875e-38F

//#define FLT_EPSILON        1.1920928955078125e-7
//#define DBL_EPSILON        2.2204460492503131e-16

#else
#error You loose, choose an appropriate floating point option ! 
#endif             /* end M881/MFFP/MIEEE */

#ifndef M_PI_2
#define M_PI_2 PID2
#endif
 
#elif defined(_AIX) || defined(__hpux) || defined(sun) || defined(__mips) || \
      defined(__linux__) || defined(__osf__) || defined(__EMX__)
 
union UDDLL { unsigned long ll[2]; double dd; };

/*
static union UDDLL uDBL_MIN = { 0x00100000, 0x00000000 };
#undef DBL_MIN
#define DBL_MIN (uDBL_MIN.dd)
*/
#ifndef DBL_QNAN
#ifndef _QNAN
static union UDDLL uDBL_QNAN = { 0x7FF80000, 0x00000000 };
#define DBL_QNAN (uDBL_QNAN.dd)
#else
#define DBL_QNAN _QNAN
#endif
#endif
 
#define PI M_PI
 
#elif ( defined(MVS) || defined(mvs) )
 
#define M_PI 3.141592653589793238462643E0
#define PI M_PI
#define min(a,b) ( (a) < (b) ) ? (a) : (b)
#define max(a,b) ( (a) > (b) ) ? (a) : (b)
 
#else
#error You loose, you should not use this computer
#endif

#define DBL_SKIP -DBL_MAX
/*
   --- action flags and constants
*/
                                   /* for the v1dlap*() routine(s) */
enum { V1DLAP_ERR=-1, V1DLAP_FULL, V1DLAP_PART,
       V1DLAP_NONE, V1DLAP_TOUCH, V1DLAP_EXACT };
/*
   --- FORTRAN entries
*/
#if defined(_AIX) || defined(ultrix)
void vcvdx_( double *, double *, int *, int *, long *, int *);
void vwwdx_( double *, double *, double *, int *, long *, int *);
void vnt1d_( double *, int *, double *, int *, int *, double *);
void vnv2dd_( double *, double *, int *, double *, int *, int *, double *);
#endif
#if defined(MVS) || defined(mvs)
void vcvdx ( double *, double *, int *, int *, long *, int *);
void vwwdx ( double *, double *, double *, int *, long *, int *);
void vnt1d ( double *, int *, double *, int *, int *, double *);
void vnv2dd ( double *, double *, int *, double *, int *, int *, double *);
#endif
/*
   --- C entries
*/
#if defined(MVS) || defined(mvs)
int vcvdx_( double *, double , int , int , long *);
int vwwdx_( double *, double *, double *, int, long * );
void vnt1d_( double *, int, double *, int, int, double *);
void vnv2dd_( double *, double *, int, double *, int, int, double *);
#define vcvdx  vcvdx_
#define vwwdx  vwwdx_
#define vnt1d  vnt1d_
#define vnv2dd vnv2dd_
#else
int vcvdx( double *, double , int , int , long *);
int vwwdx( double *, double *, double *, int, long * );
void vnt1d( double *, int, double *, int, int, double *);
void vnv2dd( double *, double *, int, double *, int, int, double *);
#endif
 
void vnt2d( double *, double *, int, double *, int, int, double *);
void vbind( double *, int, int, double *, int, long *, int );
int vcvdb( double *, double , int , int , long *);

int vnear( double *, long, long, double *, long, long *, long );
int vnodup( double *, int, int, double *, int );
 
long vadd( double *, long, double *, long, double *, long, long);
long vsub( double *, long, double *, long, double *, long, long);
long vmul( double *, long, double *, long, double *, long, long);
long vdiv( double *, long, double *, long, double *, long, long);
 
long vneg  ( double *, long, double *, long, long);
void vmrot ( double *, long, long, double *, long, long);
void vmov  ( double *, long, double *, long, long);
long vabs  ( double *, long, double *, long, long);
void vimov ( long *, long, long *, long, long);

long svsub( double, double *, long, double *, long, long);
long svdiv( double, double *, long, double *, long, long);
long svpow( double, double *, long, double *, long, long);

void v10tox( double *, long, double *, long, long);

long vlog10( double *, long, double *, long, long);
long vlog  ( double *, long, double *, long, long);
long vlog2 ( double *, long, double *, long, long);
long vexp  ( double *, long, double *, long, long);
long vsqrt ( double *, long, double *, long, long);
long vsin  ( double *, long, double *, long, long);
long vcos  ( double *, long, double *, long, long);
long vcosd ( double *, long, double *, long, long);
long vacos ( double *, long, double *, long, long);
long vasin ( double *, long, double *, long, long);
long vatan ( double *, long, double *, long, long);
long vacosd( double *, long, double *, long, long);
long vtan  ( double *, long, double *, long, long);
long vasinh ( double *, long, double *, long, long);
long vacosh ( double *, long, double *, long, long);
long vatanh ( double *, long, double *, long, long);
long vsinh ( double *, long, double *, long, long);
long vcosh ( double *, long, double *, long, long);
long vtanh ( double *, long, double *, long, long);
long vpow  ( double *, long, double *, long, double *, long, long);

/*
   --- OS-dependent math functions
*/
#if defined(AMIGA) || defined(__EMX__)
double erf(double);
#endif

#if defined(AMIGA) 
double logb(double);
#endif

#if defined(sun) || defined(__hpux)
#elif defined(AMIGA) || defined(_AIX) || defined(__EMX__) || defined(__osf__) \
                     || defined(__mips) || (__linux__) 
double lgamma_r( double, int *);
#else
#error What about a native lgamma_r function ??
#endif
/*
   --- more special math functions
*/
double beta( double, double );
double betainc( double, double, double );
double gammainc( double, double );
double erfinv( double );
                                      /* */
double tDist   ( double, int );
double tProb   ( double, int );
double tQuantil( double, int );
double chiDist   ( double, int );
double chiProb   ( double, int );
double chiQuantil( double, int );
                                      /* */
double e1( double );
/*
double sincos( double, double [2] );
*/ 
double powi( double, int );
double powd( double, double );
long vsmul( double *, long, double, double *, long, long);
long vsadd( double *, long, double, double *, long, long);
long vspow( double *, long, double, double *, long, long);
long vspowi(double *, long,    int, double *, long, long);
 
void vfill( double, double *, long, long );
void vifill( long, long *, long, long );
void vclip( double *, long, double, double, double *, long, long);
void vrampd( double, double, double *, int, int );
void vramp ( double, double, double *, int, int );
void vslope( double *, int, double *, int, double *, int, int );
int  vwsd2x( double *, int, double *, int, double *, int, long * );
int  vwsd3b( double [3][2], int, int, double *, int, double *, int, double *, long * );
int  vwbd2b( double [], int, int, int, double *, int, double *, int, long * );
int  vwsdb ( double *, int, double *, int, long * );
int  vwsdx ( double *, int, double *, int, long * );
int v1dlapd( double [2], double [2] );
 
void vscequ( double *, double *, int, double *, int, int );
void vtrafo2 ( double *, double [2][3], int, double * );
void vitrafo2( short *, double [2][3], int, double * );
void vtrafo2i( double *, double [2][3], int, short * );
void vellipse( double *, int, double * );
 
void maxv( double *, long, double *, long *, long);
void minv( double *, long, double *, long *, long);
void vmin( double *, int, double *, int, double *, int, int);
void vmax( double *, int, double *, int, double *, int, int);
void vsmax( double *, int, double, double *, int, int);
void vsma ( double *, int, double, double *, int, double *, int, int);
void vsmsa( double *, int, double, double, double *, int, int);
void vasm ( double *, int, double *, int, double, double *, int, int);
 
void vi2d( short *, long, double *, long, long);
void vl2d(  long *, long, double *, long, long);
void vd2l( double *, long,  long *, long, long);
void vd2i( double *, long,  short *, long, long);
void viclip( short *, long, short, short, short *, long, long);
void vgthx( long *, int, int, ... );
 
long vleg    ( double *, int, double *, int, double *, int, double *, int );
long vlegevn ( double *, int, double *, int, double *, int, double *, int );
long vlegodd ( double *, int, double *, int, double *, int, double *, int );
long vlegn   ( double *, int, double *, int, double *, int, double *, int );
long vlegevnn( double *, int, double *, int, double *, int, double *, int );
long vlegoddn( double *, int, double *, int, double *, int, double *, int );

void vexpon   ( double *, int, double *, int, double *, int, double *, int );
long vpoly    ( double *, int, double *, int, double *, int, double *, int );
void vlortz   ( double *, int, double *, int, double *, int, double *, int );
void vgauss   ( double *, int, double *, int, double *, int, double *, int );
void vgaussint( double *, int, double *, int, double *, int, double *, int );
 
int  Diag5( double *, double *, double *, double *, double *, double *,
            int );
int Diag5c( double *, double *, double *, double *, double *, double *,
            double *, int );
int Diag3c( double *, double *, double *, double *, int );
int splnat( double *, double *, double *,      int, double *, double *);
int splloc( double *, double *, int, double * );
int splper( double *, double *, int, double * );
int fndpeak(double *, double *, double *, double *, int, double [6],
            double *, int );
 
int   vlsqpol( double *, double *, double *, double *, int,
               double *, double *, double *, int, double *
             );
double vtrapz( double *, int, double *, int, double *, int, int );
int vmom( double *, int, double *, int, int, double [2][2], double *, int );

int vintpol1d( double *, int, int, double **, int, int, double *, int );
int vintpol1r( float  *, int, int, float  **, int, int, float  *, int );
 
double asind( double );
double acosd( double );
double atand( double );
double  sind( double );
double  cosd( double );
double  tand( double );
 
int matinv( double *, int *, int *, int, double * );
int InvMat( double *, int, int *, int *, double * );
void SrtShell( double **, int, int );
void vshsrtd ( double **, int, int, int );

double romint( 
               double (*)( double, double [], int ),
	       double [],        /* [nPar] */
	       int,
	       double [2],
	       int,
	       double,
	       double [],       /* [nHalf+1] */
	       int
             );
                                      /* number conversion functions */
int c2d ( const char *, double *);
int cn2d( const char *, int, double *);
int c2vd ( const char *, double *, int, int );
int cn2vd( const char *, int, double *, int, int );

int c2s ( const char *, float  *);
int cn2s( const char *, int, float  *);
int c2vs ( const char *, float *, int, int );
int cn2vs( const char *, int, float *, int, int );

int c2ul( const char *, unsigned long * ); 
int cn2ul( const char *, int, unsigned long * );
int c2l ( const char *, long *);
int cn2l( const char *, int, long *);
int c2vl ( const char *, long *, int, int );
int cn2vl( const char *, int, long *, int, int );

int c2w ( const char *, short *);
int cn2w( const char *, int, short *);
int c2vw ( const char *, short *, int, int );
int cn2vw( const char *, int, short *, int, int ); 
 
int c2b ( const char *, signed char *);
int cn2b( const char *, int, signed char *);
int c2vb ( const char *, signed char *, int, int );
int cn2vb( const char *, int, signed char *, int, int ); 
 
int x2ul( const char *, unsigned long * );
int x2l( const char *, long * );
int x2w( const char *, short * );
int x2b( const char *, signed char * );

double *c2vdalc( const char *, double, int * );
double *cn2vdalc( const char *, int, double, int * );

int _pilo( const char *, long * );
int _pvilo( const char *, long *, int );
int _pvrl ( const char *, double *, int );
                                      /* random generators */
				       
void vrnsd  ( unsigned long *, double, double, int, double * );
void vrnsl  ( unsigned long *, long, long, int, long * );
void vrnvd  ( unsigned long *, double *, double *, int, double * );
void vrpoisd( unsigned long *, double, int, double * );
void vrnorsd( unsigned long *, double, double, int, double * );
double _prn(void);
double _rnorm(void);

void vrnesd( unsigned long *, unsigned long *, double, double, long, double [] );
void vrnevd( unsigned long *, unsigned long *, double [], double [], long, double [] );
void vrnesl( unsigned long *, unsigned long *, long  , long  , long, long   [] );
void vrnnsd( unsigned long *, unsigned long *, double, double, long, double [] );
void vrnpsd( unsigned long *, unsigned long *, double,         long, double [] );
double vrnmind(void);

#endif

