#ifndef UMMAP_H
#define UMMAP_H
/*
   Definitions for file/memory mapping services

   Copyright  1992-2000 M.Kraemer, GSI, D-64291 Darmstadt

   $Log$

*/

#include <sys/stat.h>

#if defined(AMIGA)
#include <dos.h>
#include <clib/dos_protos.h>
#include <proto/exec.h>
#include <exec/memory.h>
#elif defined(__EMX__)
#else

#include <sys/mman.h>
//#if defined(__mips) || defined(sun)
//#define MAP_FILE MAP_RENAME
//#endif

#include <fcntl.h>

#endif

#include "uerr.h"

/*
   --- 
*/
                                      /* */
struct SUMMAP {

#if defined(AMIGA)
   BPTR psFL;
   BPTR fh;                           /* file handle */
   struct FileInfoBlock sFIB;
   long lAccess;                      /* remember read/write access */
#elif defined(__EMX__)
   FILELOCK fl;
   HFILE fh;
   FILESTATUS3 fs3;
   long lAccess;                      /* remember read/write access */
#endif
   unsigned long ulFileSize;        
   int iFile;                         /* file descriptor for memory mapping */ 
   char *pcFileName;                  /* copy of file name */    
   void *pv;                          /* ptr. to mapped memory */
   struct stat sStat;                 /* file stat */ 
   struct SUERR sUE;                  /* some error handling */
};

#define UMMAP_WRITE  0x00000001       /* file open for write */

#define UMMAP_DEBUG  0x80000000       /* general check flag */
#define UMMAP_QUIET  0x10000000       /* suppress error messages */
#define UMMAP_NOMSG  UMMAP_QUIET

                                      /* function prototypes */
int uMMapClose  ( struct SUMMAP *, unsigned long );
int uMMapDelete ( struct SUMMAP *, unsigned long );
int uMMapInit   ( struct SUMMAP *, unsigned long );
int uMMapInspect( struct SUMMAP *, unsigned long );
int uMMapIsFileMapped( struct SUMMAP *, const char *, unsigned long );
int uMMapIsValid( struct SUMMAP *, unsigned long );
int uMMapRead   ( struct SUMMAP *, const char *, unsigned long );
int uMMapWrite  ( struct SUMMAP *, const char *, unsigned long, unsigned long );

struct SUMMAP *_uMMapTest( unsigned long );

/*
   --- error codes
*/

//int uMMapError  ( struct SCMDERR *, unsigned long );

enum { ERRUMMAP_SYS=1, ERRUMMAP_BADADDR,
       ERRUMMAP_BADFILE,
       ERRUMMAP_BADMEMORY,
       ERRUMMAP_FILENOTMAPPED,
       ERRUMMAP_BADFILESIZE, 
       ERRUMMAP_BADFILENAME, 
};

#endif